Statistics
| Branch: | Revision:

root / create @ fcce5224

History | View | Annotate | Download (2.2 kB)

1 79224631 Lance Albertson
#!/bin/bash
2 79224631 Lance Albertson
3 79224631 Lance Albertson
# Copyright (C) 2007, 2008, 2009 Google Inc.
4 79224631 Lance Albertson
#
5 79224631 Lance Albertson
# This program is free software; you can redistribute it and/or modify
6 79224631 Lance Albertson
# it under the terms of the GNU General Public License as published by
7 79224631 Lance Albertson
# the Free Software Foundation; either version 2 of the License, or
8 79224631 Lance Albertson
# (at your option) any later version.
9 79224631 Lance Albertson
#
10 79224631 Lance Albertson
# This program is distributed in the hope that it will be useful, but
11 79224631 Lance Albertson
# WITHOUT ANY WARRANTY; without even the implied warranty of
12 79224631 Lance Albertson
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
13 79224631 Lance Albertson
# General Public License for more details.
14 79224631 Lance Albertson
#
15 79224631 Lance Albertson
# You should have received a copy of the GNU General Public License
16 79224631 Lance Albertson
# along with this program; if not, write to the Free Software
17 79224631 Lance Albertson
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
18 79224631 Lance Albertson
# 02110-1301, USA.
19 79224631 Lance Albertson
20 79224631 Lance Albertson
set -e
21 79224631 Lance Albertson
22 79224631 Lance Albertson
. common.sh
23 79224631 Lance Albertson
24 fcce5224 Lance Albertson
if [ "$CDINSTALL" = "no" ] ; then
25 fcce5224 Lance Albertson
    # If the target device is not a real block device we'll first losetup it.
26 fcce5224 Lance Albertson
    # This is needed for file disks.
27 fcce5224 Lance Albertson
    if [ ! -b $blockdev ]; then
28 fcce5224 Lance Albertson
      ORIGINAL_BLOCKDEV=$blockdev
29 fcce5224 Lance Albertson
      blockdev=$($LOSETUP -sf $blockdev)
30 fcce5224 Lance Albertson
      CLEANUP+=("$LOSETUP -d $blockdev")
31 fcce5224 Lance Albertson
    fi
32 fcce5224 Lance Albertson
33 fcce5224 Lance Albertson
    if [ "$PARTITION_STYLE" = "none" ]; then
34 fcce5224 Lance Albertson
      filesystem_dev=$blockdev
35 fcce5224 Lance Albertson
    elif [ "$PARTITION_STYLE" = "msdos" ]; then
36 fcce5224 Lance Albertson
      # Create one big partition, and make it bootable
37 fcce5224 Lance Albertson
      format_disk0 $blockdev
38 fcce5224 Lance Albertson
      filesystem_dev=$(map_disk0 $blockdev)
39 fcce5224 Lance Albertson
      CLEANUP+=("unmap_disk0 $blockdev")
40 fcce5224 Lance Albertson
    else
41 fcce5224 Lance Albertson
      echo "Unknown partition style $PARTITION_STYLE"
42 fcce5224 Lance Albertson
      exit 1
43 fcce5224 Lance Albertson
    fi
44 fcce5224 Lance Albertson
45 fcce5224 Lance Albertson
    mke2fs -Fjq $filesystem_dev
46 fcce5224 Lance Albertson
    root_uuid=$($VOL_ID $filesystem_dev )
47 fcce5224 Lance Albertson
48 fcce5224 Lance Albertson
    if [ -n "$swapdev" ]; then
49 fcce5224 Lance Albertson
      mkswap $swapdev
50 fcce5224 Lance Albertson
      swap_uuid=$($VOL_ID $swapdev || true )
51 fcce5224 Lance Albertson
    fi
52 fcce5224 Lance Albertson
53 fcce5224 Lance Albertson
    ##
54 fcce5224 Lance Albertson
    # Do magical restore action for fast installs here
55 fcce5224 Lance Albertson
    ##
56 fcce5224 Lance Albertson
57 fcce5224 Lance Albertson
    TMPDIR=`mktemp -d` || exit 1
58 fcce5224 Lance Albertson
    CLEANUP+=("rmdir $TMPDIR")
59 fcce5224 Lance Albertson
60 fcce5224 Lance Albertson
    mount $filesystem_dev $TMPDIR
61 fcce5224 Lance Albertson
    CLEANUP+=("umount $TMPDIR")
62 fcce5224 Lance Albertson
63 fcce5224 Lance Albertson
    RUN_PARTS=`which run-parts`
64 fcce5224 Lance Albertson
65 fcce5224 Lance Albertson
    if [ -n "$RUN_PARTS" -a -n "$CUSTOMIZE_DIR" -a -d "$CUSTOMIZE_DIR" ]; then
66 fcce5224 Lance Albertson
      TARGET=$TMPDIR
67 fcce5224 Lance Albertson
      BLOCKDEV=$blockdev
68 fcce5224 Lance Albertson
      FSYSDEV=$filesystem_dev
69 fcce5224 Lance Albertson
      export TARGET SUITE ARCH PARTITION_STYLE EXTRA_PKGS BLOCKDEV FSYSDEV
70 fcce5224 Lance Albertson
      $RUN_PARTS $CUSTOMIZE_DIR
71 fcce5224 Lance Albertson
    fi
72 79224631 Lance Albertson
fi
73 79224631 Lance Albertson
74 79224631 Lance Albertson
# execute cleanups
75 79224631 Lance Albertson
cleanup
76 79224631 Lance Albertson
trap - EXIT
77 79224631 Lance Albertson
78 79224631 Lance Albertson
exit 0